*** PROGRAM...: KEYPRESS.PRG
***           : Procedure file to process key presses and validate on the fly
*** AUTHOR....: Vic Bilson CIS:73277,1512
*** DATE......: March 29, 1987
*** NOTE......: This is an experimental program only that I quickly wrote
***             in response to another users needs and my curiosity.
***             Please excuse the sloppy code as it's designed to pique your
***             interest and for you to tweek for your needs.  If you
***             have any comments or make some modification that make it
***             work better, I would love to see them.
***             No guarantees or warranties of any kind.
***             Use at your own risk.

***  For acceptable speed, I recommend this be compiled as it runs rather
***  slow in interpreted dBase.

***  A Cursor Off routine needs to be loaded in the calling program
***  as this routine creates it's own cursor.

***  Parameters passed to this routine must be initialized in calling program
***  ROW = line where you want text to be printed in your application.
***  COL = column where you want text to be printed in your application
***  STRING = variable to pass verified text back to calling program

PROCEDURE KEYPRESS
PARAMETERS ROW,COL,STRING,LENGTH

SET ESCAPE OFF                         && Set off so that it can be filtered

STORE COL TO BEGIN                     && To Compare length of string & newstr

STORE " " TO newstr                    && Variable newstr must be at least
                                       &&  one character long for later use by
                                       &&  a SUBSTR function.

STORE CHR(95) TO CURSOR                && Create cursor character
                                       && This can be changed to your liking

CALL CURSOFF                           && Turn DOS cursor off

SET COLOR TO +/W+*
@ ROW,COL SAY CURSOR                   && Display flashing cursor at beginning
SET COLOR TO W                         &&  location

I = 0
DO WHILE I <> 13                       && Continue processing characters
   I = 0                               && until ENTER is pressed to accept
   DO WHILE I = 0                      && string.
      I = INKEY()
   ENDDO

*** The following CASE statements can be modified to test for valid or
*** invalid keypresses depending upon your requirements.  What I've done
*** here is just to give you an example of what can be done.  It will be
*** up to you to customize for your applications.

   DO CASE                             && Filter keypress and determine action
      CASE I>0 .AND. I<32
         IF I>0 .AND. I<7              && Filter out for no action
            LOOP
         ENDIF
         IF I=8 .OR. I=7               && Pressed back space
            IF COL<=BEGIN              && If cursor in beginning position
               LOOP                    &&  do nothing
            ELSE
               COL=COL-1               && Decrement curor position
               SET COLOR TO +/W*+      && Set attribute to match GET
               @ ROW,COL SAY CURSOR
               SET COLOR TO W          && Reset attribute
               @ ROW,COL+1 SAY CHR(219)&& Erase current character
            ENDIF
            LOOP
         ENDIF
         IF I>7 .AND. I<19             && Filter out for no action
            LOOP
         ENDIF
         IF I=19                       && Pressed back arrow
            IF COL<=BEGIN
               LOOP
            ELSE
               COL=COL-1
               SET COLOR TO +/W*+
               @ ROW,COL SAY CURSOR
               SET COLOR TO W
               @ ROW,COL+1 SAY CHR(219)
            ENDIF
            LOOP
         ENDIF
         IF I>19 .AND. I<27            && Filter out for no action
            LOOP
         ENDIF
         IF I=27                       && Pressed escape key
            EXIT
         ENDIF
         IF I>27 .AND. I<32            && Filter out for no action
            LOOP
         ENDIF
      CASE I>126
         IF I=127                      && Pressed Delete key
            IF COL<=BEGIN
               LOOP
            ELSE
               COL=COL-1               && Decrement curor position
               SET COLOR TO +/W*+
               @ ROW,COL SAY CURSOR
               SET COLOR TO W
               @ ROW,COL+1 SAY CHR(219)&& Erase current character
            ENDIF
            LOOP
         ELSE                          && Filter out everything above decimal
            LOOP                       && except delete key
         ENDIF
   ENDCASE

*** All characters between decimal 33 and decimal 126 are allowed
*** They contain all upper and lower case alpha numeric characters

*** Build newstr variable from each keystroke
   STORE SUBSTR(newstr,1,col+1-begin)+chr(I) TO newstr

   SET COLOR TO +/W
   @ ROW,COL SAY CHR(I)                && Display character
   SET COLOR TO +/W*+
   @ ROW,COL+1 SAY CURSOR              && Increment cursor position
   SET COLOR TO W
   STORE COL+1 TO COL                  && Increment col position for next char
   IF COL-BEGIN = length               && If newstr is maximum length
      EXIT                             && Exit loop to calling program
   ENDIF
ENDDO

IF .NOT. I=13 .AND. .NOT. I=27         && If not exiting with Enter key
   STORE CHR(255) TO CURSOR            && Turn off custom cursor
   @ ROW,COL SAY CURSOR
ELSE                                   && Exiting with Enter key
   STORE CHR(219) TO CURSOR
   @ ROW,COL SAY CURSOR
ENDIF

STORE newstr TO string                 && Store new string to variable to
                                       &&   pass to calling program
CALL CURSON                            && Turn DOS cursor back on

* EOF: KEYPRESS.PRG